-- Monitored Skills
local TotalSS = 0
local TotalEv = 0
-- Monitor Flag
local Monitor = 0

-- Main Addon Frame
local frame = CreateFrame("Frame", "SDMonitor", UIParent)
frame:SetSize(200, 70)
frame:SetToplevel(true)
frame:SetMovable(true)
frame:EnableMouse(true)
frame:SetPoint("CENTER")
frame:RegisterForDrag("LeftButton")
frame:SetClampedToScreen(true)
frame:SetBackdrop({
     bgFile = [[Interface\Tooltips\UI-Tooltip-Background]], tile = true, tileSize = 16,
     edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]], edgeSize = 5,
     insets = { left = 5, right = 5, top = 5, bottom = 5 },
})
frame:SetBackdropColor(0, 0, 0)
frame:SetBackdropBorderColor(1, 1, 1)
local title = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
title:SetPoint("TOP", 0, -2)
title:SetText("SD Monitor")
title:SetTextColor(0, 1, 0)
frame.Title = title

frame:SetScript('OnDragStart', function(self) self:StartMoving() end)
frame:SetScript('OnDragStop', function(self) self:StopMovingOrSizing() end)

frame.text = frame:CreateFontString(nil, "ARTWORK")
frame.text:SetFont("Fonts\\FRIZQT__.TTF", 20)
--frame.text:SetTextColor(1, 0, 1)
frame.text:SetAllPoints(true)
frame.text:SetJustifyH("CENTER")
frame.text:SetJustifyV("CENTER")

-- Change Addon Text on frame
function frame:SetText(text)
 self.text:SetText(text)
 local width = self.text:GetStringWidth()
 local titleWidth = self.Title:GetWidth()
 width = math.max(width, titleWidth)
 self:SetWidth(width + 32)
end

-- Welcome Message


DEFAULT_CHAT_FRAME:AddMessage("Shadow Dance Monitor v1.0 loaded.", 0.0, 1.0, 0.0)
DEFAULT_CHAT_FRAME:AddMessage("Type /sdm to view status.", 0.0, 1.0, 0.0)


function SDMonitor_OnLoad(self)

end

-- Event Log Analyzer
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame:SetScript("OnEvent", function(self, event, ...)
  local timestamp, type, hideCaster,
    sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
  if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
    if (Monitor==1) then 
     if (type == "SPELL_DAMAGE" and sourceGUID==UnitGUID("player")) then    
       local spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand, multistrike  = select (12,...)
       if (spellName == "Shadowstrike") then 
          TotalSS=TotalSS+1
       end
       if (spellName == "Eviscerate") then 
          TotalEv=TotalEv+1
       end
     end
     if (type == "SPELL_MISSED" and sourceGUID==UnitGUID("player")) then
       local spellId, spellName, spellSchool, missType, isOffHand, multistrike, amountMissed = select (12,...)
       if (spellName == "Shadowstrike") then 
          TotalSS=TotalSS+1
       end
       if (spellName == "Eviscerate") then 
          TotalEv=TotalEv+1
       end
     end
    end  
  end
end);

-- Update Numbers
function SDMonitor_OnUpdate()
   if SDMONITOR_ENABLED == "0" then
     frame:Hide();
   end
 if UnitBuff("player", "Shadow Dance") then
    if (Monitor==0) then
      TotalSS=0;
      TotalEv=0;
    end
    Monitor=1;
 else
    Monitor=0;
 end
 local txt=""
 txt= "|cffffff00E:"..TotalEv.." |cffff00ffS:"..TotalSS
 frame:SetText(txt)
end

-- Handle slash commands
function SDMONITOR_Command(cmd)
if (strlower(cmd) == "on") then
	SDMONITOR_ENABLED = "1";
    DEFAULT_CHAT_FRAME:AddMessage("Shadow Dance Monitor Enabled.", 0.0, 1.0, 0.0);
    frame:Show();
end
if (strlower(cmd) == "off") then
	SDMONITOR_ENABLED = "0";
    DEFAULT_CHAT_FRAME:AddMessage("Shadow Dance Monitor Disabled.", 0.0, 1.0, 0.0);
    TotalEv=0;
    TotalSS=0;
    frame:Hide();
end
if (strlower(cmd) == "") then
    if SDMONITOR_ENABLED == "1" then
    	DEFAULT_CHAT_FRAME:AddMessage("Shadow Dance Monitor is currently Enabled.", 0.0, 1.0, 0.0);
    	DEFAULT_CHAT_FRAME:AddMessage("Type '/sdm off' to disable.", 0.0, 1.0, 0.0);
    end
    if SDMONITOR_ENABLED == "0" then
    	DEFAULT_CHAT_FRAME:AddMessage("Shadow Dance Monitor is currently Disabled.", 0.0, 1.0, 0.0);
    	DEFAULT_CHAT_FRAME:AddMessage("Type '/sdm on' to enable.", 0.0, 1.0, 0.0);
    end
end
end

-- Listener for slash command
SLASH_SDMONITOR1 = "/sdm";
SlashCmdList["SDMONITOR"] = SDMONITOR_Command;

